classification
Title: Support macOS 11 and Apple Silicon Macs
Type: Stage: patch review
Components: Build, macOS Versions: Python 3.10, Python 3.9, Python 3.8
process
Status: open Resolution:
Dependencies: Superseder:
Assigned To: ronaldoussoren Nosy List: Maxime Belanger, Mika_Hawkins, corona10, dirn, eamanu, erlendaasland, jmr, lawrence-danna-apple, mark.dickinson, mattip, miss-islington, mistydemeo, ned.deily, nieder, python-dev, ronaldoussoren, skrah
Priority: normal Keywords: patch

Created on 2020-06-24 11:51 by ronaldoussoren, last changed 2020-12-13 19:52 by ned.deily.

Pull Requests
URL Status Linked Edit
PR 21113 merged ronaldoussoren, 2020-06-24 12:10
PR 21153 merged miss-islington, 2020-06-25 14:56
PR 21154 merged miss-islington, 2020-06-25 14:56
PR 21155 merged miss-islington, 2020-06-25 14:56
PR 21174 merged ned.deily, 2020-06-27 08:20
PR 21175 merged miss-islington, 2020-06-27 08:45
PR 21176 merged miss-islington, 2020-06-27 08:45
PR 21224 closed lawrence-danna-apple, 2020-06-30 04:22
PR 21228 merged lawrence-danna-apple, 2020-06-30 04:43
PR 21239 closed lawrence-danna-apple, 2020-06-30 17:23
PR 21241 closed lawrence-danna-apple, 2020-06-30 18:23
PR 21242 closed lawrence-danna-apple, 2020-06-30 18:25
PR 21249 closed lawrence-danna-apple, 2020-07-01 01:09
PR 21266 closed lawrence-danna-apple, 2020-07-01 17:40
PR 21268 closed lawrence-danna-apple, 2020-07-01 19:02
PR 21564 closed ronaldoussoren, 2020-07-20 13:55
PR 21576 closed lawrence-danna-apple, 2020-07-21 02:28
PR 21577 closed lawrence-danna-apple, 2020-07-21 06:01
PR 21583 closed ronaldoussoren, 2020-07-21 11:27
PR 21588 closed lawrence-danna-apple, 2020-07-21 22:30
PR 22855 merged ronaldoussoren, 2020-10-21 11:23
PR 21114 closed ronaldoussoren, 2020-10-23 19:49
PR 21115 closed ronaldoussoren, 2020-10-26 05:57
PR 21246 closed lawrence-danna-apple, 2020-10-27 19:50
PR 23239 closed python-dev, 2020-11-11 18:44
PR 23280 merged ronaldoussoren, 2020-11-14 11:28
PR 23295 merged ronaldoussoren, 2020-11-15 13:35
PR 23293 merged ronaldoussoren, 2020-11-22 06:40
PR 23472 merged ned.deily, 2020-11-23 03:50
PR 23480 merged ned.deily, 2020-11-23 22:48
PR 23484 merged miss-islington, 2020-11-24 00:05
PR 23485 merged ned.deily, 2020-11-24 05:54
PR 23486 merged miss-islington, 2020-11-24 06:21
Messages (28)
msg372245 - (view) Author: Ronald Oussoren (ronaldoussoren) * (Python committer) Date: 2020-06-24 11:51
macOS 11 is darwin 20.0.0. This confuses the configure script, resulting in defining _POSIX_C_SOURCE and friends.
msg372371 - (view) Author: Ned Deily (ned.deily) * (Python committer) Date: 2020-06-25 14:55
New changeset 8ea6353f60625c96ce96588c70ff24a77f8c71f9 by Ronald Oussoren in branch 'master':
BPO-41100: Support macOS 11 when building (GH-21113)
https://github.com/python/cpython/commit/8ea6353f60625c96ce96588c70ff24a77f8c71f9
msg372374 - (view) Author: miss-islington (miss-islington) Date: 2020-06-25 15:13
New changeset ad7a66731f2681c626f32f097e1e91cdc02330ab by Miss Islington (bot) in branch '3.9':
BPO-41100: Support macOS 11 when building (GH-21113)
https://github.com/python/cpython/commit/ad7a66731f2681c626f32f097e1e91cdc02330ab
msg372375 - (view) Author: miss-islington (miss-islington) Date: 2020-06-25 15:15
New changeset c4a53e48a98b3d8fdcfc11d1b5af3ea0dd987a88 by Miss Islington (bot) in branch '3.8':
BPO-41100: Support macOS 11 when building (GH-21113)
https://github.com/python/cpython/commit/c4a53e48a98b3d8fdcfc11d1b5af3ea0dd987a88
msg372376 - (view) Author: Ned Deily (ned.deily) * (Python committer) Date: 2020-06-25 15:15
New changeset cfbc759f918d646a59acb99251fc10b3900248a6 by Miss Islington (bot) in branch '3.7':
BPO-41100: Support macOS 11 when building (GH-21113) (GH-21155)
https://github.com/python/cpython/commit/cfbc759f918d646a59acb99251fc10b3900248a6
msg372456 - (view) Author: Ned Deily (ned.deily) * (Python committer) Date: 2020-06-27 08:44
New changeset 2f168c6356f92c38ae7751d2faf2b266a9356229 by Ned Deily in branch 'master':
bpo-41100: clarify NEWS item about macOS 11 support (GH-21174)
https://github.com/python/cpython/commit/2f168c6356f92c38ae7751d2faf2b266a9356229
msg372457 - (view) Author: miss-islington (miss-islington) Date: 2020-06-27 08:51
New changeset 1a0c581a94892fbd8fa70905130776ef7a059d97 by Miss Islington (bot) in branch '3.9':
bpo-41100: clarify NEWS item about macOS 11 support (GH-21174)
https://github.com/python/cpython/commit/1a0c581a94892fbd8fa70905130776ef7a059d97
msg372458 - (view) Author: miss-islington (miss-islington) Date: 2020-06-27 08:52
New changeset 027bba2eada175358a7f34cad155b25e1b805082 by Miss Islington (bot) in branch '3.8':
bpo-41100: clarify NEWS item about macOS 11 support (GH-21174)
https://github.com/python/cpython/commit/027bba2eada175358a7f34cad155b25e1b805082
msg372652 - (view) Author: Ned Deily (ned.deily) * (Python committer) Date: 2020-06-30 04:30
[Moving the discussion from Issue41164 to here.]

The change in PR 21224 may be needed to successfully build but I'm not sure whether that LIBTOOL_CRUFT stuff is still needed. With a squick search, I don't see any references to it anymore. But it won't hurt to add it.
msg372672 - (view) Author: Stefan Krah (skrah) * (Python committer) Date: 2020-06-30 09:15
New changeset 604d95e235d86465b8c17f02095edcaf18464d4c by Lawrence D'Anna in branch 'master':
bpo-41100: fix _decimal for arm64 Mac OS (GH-21228)
https://github.com/python/cpython/commit/604d95e235d86465b8c17f02095edcaf18464d4c
msg372680 - (view) Author: Ronald Oussoren (ronaldoussoren) * (Python committer) Date: 2020-06-30 11:12
A first testrun on the arm-mac resulted in test failures in test_distutils (in particular test_deployment_target_default in the distutils test).  That's something I have to investigate further.
msg372716 - (view) Author: Lawrence D'Anna (lawrence-danna-apple) * Date: 2020-06-30 18:29
I've created 3 patches for ctypes

* use system libffi instead of vendored one on Mac OS 10.15 and up
* use correct ABI for variadic functions on arm64
* check for libs in the dyld shared cache

With those, test_ctypes should all pass on arm64
msg374315 - (view) Author: Ronald Oussoren (ronaldoussoren) * (Python committer) Date: 2020-07-26 14:31
PR21564 is my attempt to merge all changes needed to support macOS 11 and arm64.  To be honest I had lost track of what's needed.

With this the patch the tests pass on my DTK system. 

TODO:
- Verify builds on older macOS versions
- Maybe: support building using non-system libffi on macOS


PR 21583 is a separate attempt at doing the code changes that are needed to build with the latest SDK and deploy on macOS 10.9.  This patch is still in a fairly rough state, and needs more testing (I haven't done any testing on older platforms yet)

TODO:
- Test on macOS 10.9
- Tweak the build-installer script and possibly _osx_support.py: the minimal deployment target for arm64 should be macOS 11.0.
- Tweak the build-installer script to build an optimised version

TDB:
- Keep this as two separate PRs or merge them? 
  The latter makes testing easier, but review harder
msg375532 - (view) Author: Mika Hawkins (Mika_Hawkins) Date: 2020-08-17 08:17
Hi,
What you can do is to verify builds on older macOS versions and you can also support building using non-system libffi on macOS.

Hope this hhelps...

Regards,
Mika Hawkins
msg375572 - (view) Author: Ned Deily (ned.deily) * (Python committer) Date: 2020-08-17 22:25
New changeset a0ad82959652ff64c99231f457fd740b17330514 by Ned Deily in branch '3.7':
bpo-41100: additional fixes for testing on macOS 11 Big Sur Intel
https://github.com/python/cpython/commit/a0ad82959652ff64c99231f457fd740b17330514
msg379230 - (view) Author: Ronald Oussoren (ronaldoussoren) * (Python committer) Date: 2020-10-21 18:46
https://github.com/python/cpython/pull/22855 is currently the most complete PR, and should be almost ready for merging (although there hasn't been any code review at this point).
msg380538 - (view) Author: Ronald Oussoren (ronaldoussoren) * (Python committer) Date: 2020-11-08 09:05
New changeset 41761933c1c30bb6003b65eef1ba23a83db4eae4 by Ronald Oussoren in branch 'master':
bpo-41100: Support macOS 11 and Apple Silicon (GH-22855)
https://github.com/python/cpython/commit/41761933c1c30bb6003b65eef1ba23a83db4eae4
msg381091 - (view) Author: mattip (mattip) * Date: 2020-11-16 12:02
Over at NumPy we are getting reports that some python built for macOSx 11 is not accepting wheels with the `macosx_10_9_x86_64` platform tag. Could it be related to this issue, another open issue, or some other provider's python? xref https://github.com/numpy/numpy/issues/17784
msg381097 - (view) Author: Ned Deily (ned.deily) * (Python committer) Date: 2020-11-16 13:12
@mattip, it could also be due to https://github.com/pypa/packaging/pull/319. I’m away from the keyboard fir the moment and can’t investigate further.
msg381585 - (view) Author: Ned Deily (ned.deily) * (Python committer) Date: 2020-11-22 02:17
New changeset 442746af649cc2c20d690acfabf44ab0e06c36b4 by Ronald Oussoren in branch 'master':
bpo-41100: Stripping '-arch arm64' didn't work after all (GH-23280)
https://github.com/python/cpython/commit/442746af649cc2c20d690acfabf44ab0e06c36b4
msg381608 - (view) Author: Ronald Oussoren (ronaldoussoren) * (Python committer) Date: 2020-11-22 10:18
New changeset e8b1c038b14b5fc8120aab62c9bf5fb840274cb6 by Ronald Oussoren in branch '3.9':
[3.9] bpo-41100: Support macOS 11 and Apple Silicon (GH-22855) (GH-23295)
https://github.com/python/cpython/commit/e8b1c038b14b5fc8120aab62c9bf5fb840274cb6
msg381640 - (view) Author: Ned Deily (ned.deily) * (Python committer) Date: 2020-11-23 04:43
New changeset 5aa6c99da1087ded0ccb99bb12591e5ab31d75c3 by Ned Deily in branch '3.9':
bpo-41100: Update Whatsnew and installer ReadME for 3.9.1 (GH-23472)
https://github.com/python/cpython/commit/5aa6c99da1087ded0ccb99bb12591e5ab31d75c3
msg381701 - (view) Author: Ned Deily (ned.deily) * (Python committer) Date: 2020-11-24 00:04
New changeset 936533ca0415c40dc64ccb5f8857720f32b3fcb4 by Ned Deily in branch 'master':
bpo-41100: minor build installer fixes (GH-23480)
https://github.com/python/cpython/commit/936533ca0415c40dc64ccb5f8857720f32b3fcb4
msg381702 - (view) Author: miss-islington (miss-islington) Date: 2020-11-24 00:26
New changeset 3266991e721286e942125350ca41e1403d8384d6 by Miss Islington (bot) in branch '3.9':
bpo-41100: minor build installer fixes (GH-23480)
https://github.com/python/cpython/commit/3266991e721286e942125350ca41e1403d8384d6
msg381708 - (view) Author: Ned Deily (ned.deily) * (Python committer) Date: 2020-11-24 06:20
New changeset c0c23ea72b76b06b7db0d09415fa90bab8ded63a by Ned Deily in branch 'master':
bpo-41100: in test_platform, ignore 10.16 (GH-23485)
https://github.com/python/cpython/commit/c0c23ea72b76b06b7db0d09415fa90bab8ded63a
msg381709 - (view) Author: Ned Deily (ned.deily) * (Python committer) Date: 2020-11-24 06:34
New changeset 96d906b144e6e6aa96c5ffebecbcc5d38034bbda by Miss Islington (bot) in branch '3.9':
bpo-41100: in test_platform, ignore 10.16 (GH-23485) (GH-23486)
https://github.com/python/cpython/commit/96d906b144e6e6aa96c5ffebecbcc5d38034bbda
msg382932 - (view) Author: Joshua Root (jmr) * Date: 2020-12-13 13:34
Are there plans to backport PR 22855 to any branches older than 3.9?
msg382939 - (view) Author: Ned Deily (ned.deily) * (Python committer) Date: 2020-12-13 19:52
> Are there plans to backport PR 22855 to any branches older than 3.9?

The plan is to also support 3.8 on Big Sur and Apple Silicon as 3.8 is still in bugfix mode.  There are no plans to backport support to 3.7 and 3.6 which are in the security-fix-only phase of their release cycles.
History
Date User Action Args
2020-12-13 19:52:54ned.deilysetmessages: + msg382939
2020-12-13 13:34:20jmrsetnosy: + jmr
messages: + msg382932
2020-12-01 14:23:02ronaldoussorenunlinkissue40060 dependencies
2020-11-28 21:38:45dirnsetnosy: + dirn
2020-11-24 06:34:28ned.deilysetmessages: + msg381709
2020-11-24 06:21:00miss-islingtonsetpull_requests: + pull_request22373
2020-11-24 06:20:45ned.deilysetmessages: + msg381708
2020-11-24 05:54:30ned.deilysetpull_requests: + pull_request22372
2020-11-24 00:26:35miss-islingtonsetmessages: + msg381702
2020-11-24 00:05:03miss-islingtonsetpull_requests: + pull_request22371
2020-11-24 00:04:48ned.deilysetmessages: + msg381701
2020-11-23 22:48:37ned.deilysetpull_requests: + pull_request22370
2020-11-23 04:43:20ned.deilysetmessages: + msg381640
2020-11-23 03:50:37ned.deilysetpull_requests: + pull_request22362
2020-11-23 01:38:29ned.deilysetpull_requests: - pull_request21922
2020-11-22 10:18:45ronaldoussorensetmessages: + msg381608
2020-11-22 06:40:55ronaldoussorensetpull_requests: + pull_request22349
2020-11-22 02:17:27ned.deilysetmessages: + msg381585
2020-11-16 13:12:53ned.deilysetmessages: + msg381097
2020-11-16 12:05:33MaxDesiatovsetnosy: - MaxDesiatov
2020-11-16 12:02:14mattipsetnosy: + mattip
messages: + msg381091
2020-11-15 13:44:13ned.deilysettitle: Build failure on macOS 11 (beta) -> Support macOS 11 and Apple Silicon Macs
2020-11-15 13:35:22ronaldoussorensetpull_requests: + pull_request22186
2020-11-14 11:28:42ronaldoussorensetpull_requests: + pull_request22174
2020-11-13 12:20:42niedersetnosy: + nieder
2020-11-11 19:46:25MaxDesiatovsetnosy: + MaxDesiatov
2020-11-11 18:44:30python-devsetnosy: + python-dev
pull_requests: + pull_request22136
2020-11-08 12:07:24ronaldoussorenlinkissue28491 superseder
2020-11-08 12:07:24ronaldoussorenunlinkissue28491 dependencies
2020-11-08 12:03:40ronaldoussorenlinkissue37586 superseder
2020-11-08 12:03:40ronaldoussorenunlinkissue37586 dependencies
2020-11-08 09:27:53ronaldoussorenunlinkissue31359 dependencies
2020-11-08 09:27:53ronaldoussorenlinkissue31359 superseder
2020-11-08 09:27:05ronaldoussorenlinkissue34597 superseder
2020-11-08 09:27:05ronaldoussorenunlinkissue34597 dependencies
2020-11-08 09:05:30ronaldoussorensetmessages: + msg380538
2020-11-01 16:45:14ronaldoussorenlinkissue42235 dependencies
2020-10-27 19:50:25lawrence-danna-applesetpull_requests: + pull_request21923
2020-10-27 19:38:26mistydemeosetnosy: + mistydemeo
pull_requests: + pull_request21922
2020-10-26 05:57:07ronaldoussorensetpull_requests: + pull_request21899
2020-10-25 11:23:18ronaldoussorenlinkissue34597 dependencies
2020-10-23 19:50:48ronaldoussorenlinkissue41101 superseder
2020-10-23 19:49:59ronaldoussorensetpull_requests: + pull_request21849
2020-10-23 15:06:35ronaldoussorenlinkissue40060 dependencies
2020-10-23 10:33:16ronaldoussorenlinkissue37586 dependencies
2020-10-23 09:16:08ronaldoussorenlinkissue31359 dependencies
2020-10-23 09:08:35ronaldoussorenlinkissue28491 dependencies
2020-10-21 18:46:07ronaldoussorensetmessages: + msg379230
2020-10-21 11:23:18ronaldoussorensetpull_requests: + pull_request21799
2020-10-19 10:09:29ronaldoussorenlinkissue42056 superseder
2020-08-17 22:25:43ned.deilysetmessages: + msg375572
2020-08-17 08:17:38Mika_Hawkinssetnosy: + Mika_Hawkins
messages: + msg375532
2020-08-12 22:48:20Maxime Belangersetnosy: + Maxime Belanger
2020-07-26 14:31:40ronaldoussorensetmessages: + msg374315
2020-07-26 14:14:50ronaldoussorenlinkissue41090 superseder
2020-07-22 17:10:15erlendaaslandsetnosy: + erlendaasland
2020-07-21 22:30:24lawrence-danna-applesetpull_requests: + pull_request20728
2020-07-21 11:27:32ronaldoussorensetpull_requests: + pull_request20724
2020-07-21 06:01:51lawrence-danna-applesetpull_requests: + pull_request20721
2020-07-21 02:28:12lawrence-danna-applesetpull_requests: + pull_request20720
2020-07-20 13:55:23ronaldoussorensetpull_requests: + pull_request20709
2020-07-02 02:22:48eamanusetnosy: + eamanu
2020-07-01 19:14:49mark.dickinsonsetnosy: + mark.dickinson
2020-07-01 19:02:47lawrence-danna-applesetpull_requests: + pull_request20418
2020-07-01 17:40:01lawrence-danna-applesetpull_requests: + pull_request20414
2020-07-01 07:38:29ronaldoussorenlinkissue41179 superseder
2020-07-01 01:09:06lawrence-danna-applesetpull_requests: + pull_request20399
2020-06-30 18:29:07lawrence-danna-applesetmessages: + msg372716
2020-06-30 18:25:26lawrence-danna-applesetpull_requests: + pull_request20394
2020-06-30 18:23:27lawrence-danna-applesetpull_requests: + pull_request20393
2020-06-30 17:23:35lawrence-danna-applesetpull_requests: + pull_request20391
2020-06-30 11:12:47ronaldoussorensetmessages: + msg372680
2020-06-30 09:15:56skrahsetnosy: + skrah
messages: + msg372672
2020-06-30 04:43:07lawrence-danna-applesetpull_requests: + pull_request20382
2020-06-30 04:33:11corona10setnosy: + corona10
2020-06-30 04:30:15ned.deilysetmessages: + msg372652
2020-06-30 04:25:34ned.deilylinkissue41164 superseder
2020-06-30 04:22:25lawrence-danna-applesetnosy: + lawrence-danna-apple
pull_requests: + pull_request20381
2020-06-27 08:52:53miss-islingtonsetmessages: + msg372458
2020-06-27 08:51:59miss-islingtonsetmessages: + msg372457
2020-06-27 08:45:38miss-islingtonsetpull_requests: + pull_request20334
2020-06-27 08:45:28miss-islingtonsetpull_requests: + pull_request20333
2020-06-27 08:44:59ned.deilysetmessages: + msg372456
2020-06-27 08:20:36ned.deilysetpull_requests: + pull_request20332
2020-06-25 15:15:55ned.deilysetmessages: + msg372376
2020-06-25 15:15:10miss-islingtonsetmessages: + msg372375
2020-06-25 15:13:43miss-islingtonsetmessages: + msg372374
2020-06-25 14:56:22miss-islingtonsetpull_requests: + pull_request20314
2020-06-25 14:56:15miss-islingtonsetpull_requests: + pull_request20313
2020-06-25 14:56:07miss-islingtonsetnosy: + miss-islington
pull_requests: + pull_request20312
2020-06-25 14:55:57ned.deilysetmessages: + msg372371
2020-06-24 12:10:37ronaldoussorensetkeywords: + patch
stage: patch review
pull_requests: + pull_request20276
2020-06-24 11:51:07ronaldoussorencreate